#include "pear_event.h"
#include "pear_update.h"

#ifndef BUF_SIZE
#define BUF_SIZE 65535
#endif


// ----------------------- init  -------------------------
//
struct ev_loop *loop;


void pear_event_init(void)
{
	loop = EV_DEFAULT;
}


// ----------------------- signal  -------------------------
//
struct ev_signal sigint_watcher;
struct ev_signal sigterm_watcher;


static void signal_cb_update(EV_P_ ev_signal *w, int revents)
{
    if (revents & EV_SIGNAL) {
        switch (w->signum) {
            case SIGINT:
            case SIGTERM:
                ev_unloop(EV_A_ EVUNLOOP_ALL);
                break;

            default:
                break;
        }
    }
}


void pear_event_set_signals_for_update(void)
{
    ev_signal_init(&sigint_watcher, signal_cb_update, SIGINT);
    ev_signal_init(&sigterm_watcher, signal_cb_update, SIGTERM);
    ev_signal_start(loop, &sigint_watcher);
    ev_signal_start(loop, &sigterm_watcher);
}


// ----------------------- update timer  -------------------------
//
ev_timer pear_timeout_update_watcher;


void pear_event_update(void)
{
    pear_update(pear_update_info.curl,
                pear_machine_info.host_ip,
                pear_machine_info.mac,
                pear_machine_info.extern_ip,
                pear_update_info.package,
                pear_update_info.version);
}


void pear_event_set_update_timer(void)
{
    srandom(time(NULL));

//                    random() % PEAR_TIMEOUT_UPDATE_OUTSIDE,
    ev_timer_init (&pear_timeout_update_watcher,
                    pear_event_update,
                    0,
                    random() % PEAR_TIMEOUT_UPDATE_OUTSIDE + PEAR_TIMEOUT_UPDATE_OUTSIDE);

    ev_timer_start (loop, &pear_timeout_update_watcher);
}


// ----------------------- run and stop  -------------------------
//
void pear_event_run(void)
{
	ev_run(loop, 0);
}


void pear_event_stop(void)
{
	ev_signal_stop(EV_DEFAULT, &sigint_watcher);
    
    ev_signal_stop(EV_DEFAULT, &sigterm_watcher);
}






