#ifndef __PEAR_EVENT_H_
#define __PEAR_EVENT_H_

#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#ifndef __MINGW32__
#include <netdb.h>
#include <errno.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <pthread.h>
#include <sys/un.h>
#include <sys/socket.h>
#endif


#ifdef __MINGW32__
#include "win32.h"
#endif

#if defined(HAVE_SYS_IOCTL_H) && defined(HAVE_NET_IF_H) && defined(__linux__)
#include <net/if.h>
#include <sys/ioctl.h>
#define SET_INTERFACE
#endif

#include <ev.h>
#include "pear_configure.h"
#include "jconf.h"
#include "utils.h"
#include "pear_option.h"
#include "pear_syslog.h"
#include "pear_signal.h"
#include "pear_utils.h"
#include "pear_version.h"


struct manager_ctx {
    ev_io io;
    int fd;
    int fast_open;
    int verbose;
    int mode;
    int auth;
    char *password;
    char *timeout;
    char *method;
    char *iface;
    char *acl;
    char *user;
    char *manager_address;
    char **hosts;
    int host_num;
    char **nameservers;
    int nameserver_num;
    int mtu;
};



void pear_update_stat (char * host);


void pear_event_init(void);


void pear_event_set_signals_for_update(void);


void pear_event_set_update_timer(void);


void pear_event_run(void);


void pear_event_stop(void);



#endif


