#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "pear_update.h"
#include "pear_event.h"


pear_update_info_t pear_update_info;


void pear_update_init()
{
    if (!pear_option_info.debug) {

        int fd = open("/dev/null", O_WRONLY);

        if (fd < 0) {

            exit(1);
        }

        dup2(fd, 1);

        dup2(fd, 2);
    }

    //
    //
    memset(&pear_update_info, 0, sizeof(pear_update_info_t));

    // 
    //
#if PEAR_CURL_ENABLE_TSL
    pear_update_info.curl = "curl --insecure -fsSL --connect-timeout  10 -m 30 --header \"Content-Type: application/json\"  --header \"Cache-Control: no-cache\" ";
#else
    pear_update_info.curl = "curl --connect-timeout  10  -m 20 --header \"Content-Type: application/json\"  --header \"Cache-Control: no-cache\" ";
#endif

    //
    // 
    // sprintf(pear_log_info.logfile, "/etc/pear/pear_share/pear_update.log");

    // 
    //
    pear_machine_info_init();

    //
    //
    //pear_get_host();
}


static void pear_parse_config_file()
{
    char buf[512] = {0x00};

    FILE *fp = fopen(pear_option_info.conf_file, "r");

    if (fp == NULL)
    {
        PEAR_LOG(UPDATE, DEBUG, "Open file error");
        exit(0);
    }

    if (fread(buf, sizeof(char), 512, fp) < 0)
    {
        PEAR_LOG(UPDATE, DEBUG, "Read file error");
        exit(0);
    }
    shadow_get_json(buf, "package", pear_update_info.package);
    shadow_get_json(buf, "version", pear_update_info.version);
    printf("package:%s, version:%s\n", pear_update_info.package, pear_update_info.version);
}


// fuqiyang 2017-05-15
//
int main(int argc, char **argv)
{
	// get opt
	//
    USE_SYSLOG(argv[0]);
	pear_getopt(argc, argv);

    if (pear_option_info.conf_file == NULL)
    {
        printf("need -c config file");
        exit(0);
    }


    // set signals 
    //
    pear_set_signals();

    //
    //
    pear_event_init();

    // initialize ev loop
	//
    pear_event_set_signals_for_update();

    // init
    //
    pear_update_init();

    pear_parse_config_file();

    //
    //
	pear_event_set_update_timer();

    // start ev loop
    //
    pear_event_run();

#ifdef __MINGW32__
    winsock_cleanup();
#endif

    //
    //
    pear_event_stop();

    return 0;
}
