#ifndef _PEAR_UTILS_H
#define _PEAR_UTILS_H

#include "pear_curl.h"
#include "pear_machine.h"

enum {

    PEAR_DDNS_ERR_MEM_OVERFLOW = -9,

    PEAR_DDNS_ERR_PARAMETER,

    PEAR_DDNS_ERR_TIMEOUT,

    PEAR_DDNS_ERR_GET_CLIENT_INFO,

    PEAR_DDNS_ERR_MESSAGE,

    PEAR_DDNS_ERR_NO_RECORD,

    PEAR_DDNS_ERR_UNKNOWN
};


typedef struct {

    char login_token[64];

    char format     [8];

    char domain     [56];

    char user_agent [64];

} pear_ddns_conf_t;


typedef struct {

    pear_ddns_conf_t *conf;

    char api_url   [64];

    char query_str [512];

    char domain    [56];

} pear_ddns_req_t;


typedef struct MemoryStruct {

    char *memory;

    size_t size;

} pear_ddns_rsp_t;


typedef struct {

    pear_ddns_req_t *req;

    pear_ddns_rsp_t *rsp;

} pear_ddns_req_cxt_t;



int pear_ddns_init_conf(pear_ddns_conf_t *conf);


int pear_ddns_query(pear_ddns_req_t *req, pear_ddns_rsp_t *rsp);


void detect_hardware_platform();


int pear_mkdir(const char *file_name, int is_dir);


void pear_log_file(const char *msg);


#endif



